import { Component, Input } from '@angular/core';

@Component({
  selector: 'ngx-one-column-layout',
  styleUrls: ['./one-column.layout.scss'],
  template: `
    <nb-layout [restoreScrollTop]="false">
      <nb-layout-header fixed>
        <ngx-header></ngx-header>
      </nb-layout-header>

      <nb-sidebar *ngIf="showMenu" responsive [collapsedBreakpoints]="['xs', 'is', 'sm', 'md']" [compactedBreakpoints]="['xs', 'is', 'sm', 'md']" class="menu-sidebar" tag="menu-sidebar" >
        <ng-content select="nb-menu"></ng-content>
      </nb-sidebar>

      <nb-layout-column [class.padd]="!showMenu">
        <ng-content select="router-outlet"></ng-content>
      </nb-layout-column>

      <nb-layout-footer fixed>
        <ngx-footer></ngx-footer>
      </nb-layout-footer>
    </nb-layout>
  `,
})
export class OneColumnLayoutComponent {
  @Input() showMenu: boolean = false;
}
