import { DegreeProgram } from "app/features/modules/models/degree-program";

export class User {
    id: number;
    loginName: string;
    firstName: string;
    name: string;
    lastName: string;
    mail: string;
    program: DegreeProgram;

    constructor(user: any) {
        this.id = user.id;
        this.loginName = user.loginName;
        this.firstName = user.firstName;
        this.lastName = user.lastName;
        this.name = user.name;
        this.mail = user.mail;
        this.program = user.program ? new DegreeProgram(user.program) : null;
    }

    get hasFullName() {
        return this.firstName && this.lastName;
    }

    get fixedName() {
        if (this.hasFullName) {
            if (this.loginName) {
                return `${this.name} (${this.loginName})`;
            } else {
                return this.name;
            }
        } else {
            return this.loginName;
        }
    }
}