import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { CourseComponent } from './pages/course/course.component';
import { CoursesComponent } from './pages/courses/courses.component';
import { CourseHeaderComponent } from './components/course-header/course-header.component';
import { SharedModule } from 'app/shared/shared.module';
import { CoursesRoutingModule } from './courses-routing.module';
import { CourseParticipantAttendanceComponent } from '../attendances/components/course-participant-attendance/course-participant-attendance.component';
import { CourseUnitListComponent } from './components/course-unit-list/course-unit-list.component';
import { CourseSettingsComponent } from './pages/course-settings/course-settings.component';
import { NewCourseComponent } from './pages/new-course/new-course.component';
import { CourseUnitEventsComponent } from './components/course-unit-events/course-unit-events.component';
import { CourseUnitParticipantsComponent } from './components/course-unit-participants/course-unit-participants.component';
import { CourseUnitComponent } from './pages/course-unit/course-unit.component';
import { PermissionsComponent } from './pages/permissions/permissions.component';
import { CourseTemplateListComponent } from './components/course-template-list/course-template-list.component';
import { CourseUnitsComponent } from './pages/course-units/course-units.component';
import { ModuleMultiselectComponent } from './components/module-multiselect/module-multiselect.component';
import { LastExercisesListComponent } from './components/last-exercises-list/last-exercises-list.component';
import { CourseStaffMembershipsFormComponent } from './components/course-staff-memberships-form/course-staff-memberships-form.component';
import { CourseFilesComponent } from './pages/course-files/course-files.component';
import { CourseFileUploadComponent } from './components/course-file-upload/course-file-upload.component';
import { CourseFileListComponent } from './components/course-file-list/course-file-list.component';
import { CourseStaffComponent } from './components/course-staff/course-staff.component';
import { DialogAddParticipantComponent } from './dialogs/dialog-add-participant/dialog-add-participant.component';
import { DialogAddStaffMembershipComponent } from './dialogs/dialog-add-staff-membership/dialog-add-staff-membership.component';

@NgModule({
  declarations: [
    CoursesComponent,
    CourseComponent,
    NewCourseComponent,
    CourseSettingsComponent,
    CourseUnitComponent,
    PermissionsComponent,

    DialogAddParticipantComponent,
    DialogAddStaffMembershipComponent,

    CourseHeaderComponent,
    CourseUnitListComponent,
    CourseUnitEventsComponent,
    CourseUnitParticipantsComponent,
    CourseTemplateListComponent,
    CourseUnitsComponent,
    ModuleMultiselectComponent,
    LastExercisesListComponent,
    CourseStaffMembershipsFormComponent,
    CourseFilesComponent,
    CourseFileUploadComponent,
    CourseFileListComponent,
    CourseStaffComponent
  ],
  imports: [
    CommonModule,
    SharedModule,
    CoursesRoutingModule
  ],
  exports: [
    CourseHeaderComponent
  ]
})
export class CoursesModule { }
