package de.hsrm.sls.subato.auth;

import de.hsrm.sls.subato.auth.principal.SubatoPrincipal;
import org.keycloak.adapters.springsecurity.authentication.KeycloakAuthenticationProvider;
import org.keycloak.adapters.springsecurity.token.KeycloakAuthenticationToken;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;
import org.springframework.stereotype.Component;

@Component
public class CustomKeycloakAuthProvider extends KeycloakAuthenticationProvider  {
    @Autowired
    KeycloakLoginHandler loginHandler;

    @Override
    public synchronized Authentication authenticate(Authentication authentication) throws AuthenticationException {
        var auth = (KeycloakAuthenticationToken) super.authenticate(authentication);
        SubatoPrincipal principal = loginHandler.handleToken(auth);
        return new UsernamePasswordAuthenticationToken(principal, auth.getAccount(), principal.getAuthorities());
    }
}
