package de.hsrm.sls.subato.auth.masking;

import de.hsrm.sls.subato.auth.masking.MaskManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.MethodParameter;
import org.springframework.http.MediaType;
import org.springframework.http.converter.json.MappingJacksonValue;
import org.springframework.http.server.ServerHttpRequest;
import org.springframework.http.server.ServerHttpResponse;
import org.springframework.web.bind.annotation.RestControllerAdvice;
import org.springframework.web.servlet.mvc.method.annotation.AbstractMappingJacksonResponseBodyAdvice;

@RestControllerAdvice
public class MaskAdvice extends AbstractMappingJacksonResponseBodyAdvice {
    @Autowired
    private MaskManager maskManager;

    @Override
    protected void beforeBodyWriteInternal(MappingJacksonValue bodyContainer, MediaType contentType, MethodParameter returnType, ServerHttpRequest request, ServerHttpResponse response) {
        var obj = bodyContainer.getValue();
        if(obj != null) {
            maskManager.mask(obj);
        }
    }
}