package de.hsrm.sls.subato.auth.policy.exercises;

import de.hsrm.sls.subato.auth.policy.CheckPolicyRequest;
import de.hsrm.sls.subato.auth.policy.PolicyRule;
import de.hsrm.sls.subato.courses.membership.StaffGroup;
import de.hsrm.sls.subato.exercises.exercise.Exercise;
import org.springframework.stereotype.Component;

/**
 * The current user is allowed to view the progress information for submissions for an exercise
 */
@Component
public class SubmissionViewProgressPolicy implements PolicyRule {
    @Override
    public boolean check(CheckPolicyRequest request) {
        if(!request.matches(ExercisesAction.SUBMISSION_VIEW_PROGRESS) || request.unauthenticated()) {
            return false;
        }

        var exercise = (Exercise) request.getObj();
        return request.getSubject().hasGroup(exercise.getCourse(), StaffGroup.LECTURER);
    }
}
