package de.hsrm.sls.subato.courses.membership;

import de.hsrm.sls.subato.courses.course.Course;
import de.hsrm.sls.subato.user.User;

import javax.persistence.*;
import java.util.Objects;

@Entity
@IdClass(CourseStaffMembershipPK.class)
@Table(name = "course_staff_memberships")
public class CourseStaffMembership {
    @Id
    @ManyToOne
    @JoinColumn(name = "user_id")
    private User user;

    @Id
    @ManyToOne
    @JoinColumn(name = "course_id")
    private Course course;

    @Id
    @Column(name = "group_id", insertable = false, updatable = false)
    private StaffGroup group;

    public CourseStaffMembership(User user, Course course, StaffGroup group) {
        this.user = user;
        this.course = course;
        this.group = group;
    }

    public CourseStaffMembership() {
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public Course getCourse() {
        return course;
    }

    public void setCourse(Course course) {
        this.course = course;
    }

    public StaffGroup getGroup() {
        return group;
    }

    public void setGroup(StaffGroup group) {
        this.group = group;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        CourseStaffMembership that = (CourseStaffMembership) o;
        return user.equals(that.user) && course.equals(that.course) && group == that.group;
    }

    @Override
    public int hashCode() {
        return Objects.hash(user, course, group);
    }
}
