package de.hsrm.sls.subato.solutions.evaluation.request;

import de.hsrm.sls.subato.shared.fs.FileTree;
import de.hsrm.sls.subato.tasks.stef.file.FileRef;

/**
 *  Exactly matches a source file by the path. Required, if multiple files/directories were uploaded.
 *
 *  EXAMPLE 1:
 *
 *  template path: panitz/name/First.java
 *  solution path:
 *
 *  - solutions
 *    - 17 (root)
 *      - panitz
 *          - name
 *              - First.java
 *
 *  EXAMPLE 2:
 *
 *  template path: First.java
 *  solution path:
 *
 *  - solutions
 *      - 17 (root)
 *          - First.java
 */
public class ExactMatcher implements FileMatcher {
    @Override
    public FileTree match(FileTree solutionTree, FileRef templateFile) {
        return solutionTree.find(i -> i.isSrc() && i.getPath().equals(templateFile.getPath()));
    }
}
