package de.hsrm.sls.subato.tasks.stef.file;

import de.hsrm.sls.subato.shared.fs.FileTree;

/**
 * Represents a file reference in the meta.xml in a STEF specification
 */
public class FileRef {
    private String description;

    /**
     * relative to files directory
     */
    private String path;
    private String mimeType;
    private FileType type;
    private boolean isPublic;

    /**
     * the resolved file for this reference
     */
    private FileTree file;


    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public FileTree getFile() {
        return file;
    }

    public void setFile(FileTree file) {
        this.file = file;
    }

    public String getPath() {
        return path;
    }

    public void setPath(String path) {
        this.path = path;
    }

    public FileType getType() {
        return type;
    }

    public void setType(FileType type) {
        this.type = type;
    }

    public boolean isPublic() {
        return isPublic;
    }

    public void setPublic(boolean aPublic) {
        isPublic = aPublic;
    }

    public String getMimeType() {
        return mimeType;
    }

    public FileRef setMimeType(String mimeType) {
        this.mimeType = mimeType;
        return this;
    }
}
