package de.hsrm.sls.subato.tasks.task;

import org.springframework.data.jpa.domain.Specification;

import static de.hsrm.sls.subato.tasks.task.TaskSpecifications.*;

public class TaskFilter {
    String query;
    Long poolId;

    public TaskFilter query(String query) {
        this.query = query;
        return this;
    }

    public TaskFilter poolId(Long poolId) {
        this.poolId = poolId;
        return this;
    }

    public Specification<Task> toSpecification() {
        Specification<Task> spec = Specification.where(null);

        if(poolId != null) {
            spec = spec.and(poolEquals(poolId));
        }

        if(query != null) {
            spec = spec.and(applyQuery(query));
        }

        return spec;
    }
}
