package de.hsrm.sls.subato.user;

import org.springframework.data.jpa.domain.Specification;

import static de.hsrm.sls.subato.user.UserSpecifications.*;
import static de.hsrm.sls.subato.user.UserSpecifications.applyQuery;

public class UserFilter {
    String query;
    Boolean active;
    Long unitId;
    Long courseId;

    public UserFilter query(String query) {
        this.query = query;
        return this;
    }

    public UserFilter active(Boolean active) {
        this.active = active;
        return this;
    }

    public UserFilter unitId(Long unitId) {
        this.unitId = unitId;
        return this;
    }

    public UserFilter courseId(Long courseId) {
        this.courseId = courseId;
        return this;
    }

    public Specification<User> toSpecification() {
        Specification<User> spec = Specification.where(null);

        if(active != null) {
            spec = spec.and(activeEquals(active));
        }

        if(unitId != null) {
            spec = spec.and(inUnit(unitId));
        }

        if(courseId != null) {
            spec = spec.and(inCourse(courseId));
        }

        if(query != null) {
            spec = spec.and(applyQuery(query));
        }

        return spec;
    }
}
